Name: mocka
Version: 9905
Release: 4
Summary: A complete, high performance implementation of the Modula-2 language
Copyright: Freely redistributable
Group: Development/Languages
URL: http://i44www.info.uni-karlsruhe.de/~modula/
Source0: ftp://i44ftp.info.uni-karlsruhe.de/pub/mocka/linux/Mocka%{version}.src.tar.gz
Source1: ftp://i44ftp.info.uni-karlsruhe.de/pub/mocka/linux/Mocka%{version}.bin.i386-linux.ELF.glibc.tar.gz
Patch: mocka-9905.diff
ExclusiveArch: i386
ExclusiveOS: Linux
BuildRoot: /tmp/%{name}-%{version}
Packager: Ian Macdonald <ian@caliban.org>

%changelog
* Wed Aug 13 2003  Roberto Aragn <robertoaragon@iespana.es>
[9905-4]
- M2RTS-elf.s modified to correct 'Incorrectly built binary... need to be
  fixed (caused by Native POSIX Thread Library support in RedHat9)
- Mc recompiled to avoid previous warning
- Added 'h' command to show a short description of interactive commands
- This spec-file: rpmbuild makes man pages compressed - %files modified

* Sun Oct 24 1999  Ian Macdonald <ianmacd@caliban.org>
[9905-3]
- someone changed the source tarball without updating the version number,
  so this is a recompilation using the new source

* Thu Sep  9 1999  Ian Macdonald <ianmacd@caliban.org>
- upgraded to 9905
- no longer build Mc, as some source files are missing
- man page missing, so took the one from 9903 as extra source file
- ExclusiveArch and ExclusiveOS tags added

* Tue Sep  7 1999  Ian Macdonald <ianmacd@caliban.org>
- first RPM release

%description
Preliminary MOCKA (Modula Compiler Karlsruhe) is a complete, high performance
implementation of the language Modula-2 as defined in [Wir85]. The MOCKA system
consists of a compiler, a binder, and a simple environment (including a
make-facility) supporting interactive program development. The compiler
translates Modula-2 source programs into binary machine code or assembler code.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -b 1 -n mocka
%patch -p1
mv man1/mc.1 man1/mc2.1

%build
sed -e 's@MOCKADIR=${MOCKADIR-/ben/modula/mockaXXX/i386-linux}@MOCKADIR=${MOCKADIR-'$PWD'}@' bin/mc > bin/mc2
chmod +x bin/mc2
cd sys
./asm -elf M2RTS-elf
cd ../lib
rm -f *.o
#
# Assembly files
#
for i in *.s; do
  as -o ${i%s}o $i
done
#
# C files
#
for i in *.c; do
  gcc -o ${i%c}o -c $i
done
echo "p tst" | ../bin/mc2 -noindex -norange -noS -nog -elf
cd ../src
#
# Source files missing for Mc, so don't try to compile
#
#echo 'p Mc' | ../bin/mc2
#strip Mc
# Lister won't link with our compiled version of mc2 - copy it later
# cp -pf Mc ../sys
cd ../sys
echo 'p Lister' | ../bin/mc2
strip Lister
echo 'p Unlister' | ../bin/mc2
strip Unlister
rm -f {Lister,Unlister}.{o,r}
cd ..
sed -e 's@MOCKADIR=${MOCKADIR-'$PWD'}@MOCKADIR=${MOCKADIR-/usr/lib/mocka}@' bin/mc2 > bin/mc.tmp
mv -f bin/mc.tmp bin/mc2
sed -e 's/\([Mm][Cc]\)/\12/g' man1/mc2.1 > man1/mc2.1.tmp
mv -f man1/mc2.1.tmp man1/mc2.1
# Copy our version of mc2 now
#cp -pf src/Mc sys/Mc

%install
mkdir -p $RPM_BUILD_ROOT/usr/{bin,lib/mocka,man/man1}
cp -a lib sys $RPM_BUILD_ROOT/usr/lib/mocka
install -m 755 bin/mc2 $RPM_BUILD_ROOT/usr/bin/mc2
install -m 644 man1/mc2.1 $RPM_BUILD_ROOT/usr/man/man1/mc2.1

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%doc README doc/ examples/
/usr/bin/mc2
/usr/lib/mocka
/usr/man/man1/mc2.1.gz
